mod backtrack;

use std::time::SystemTime;

use backtrack::*;

const DEFAULT_DIM: usize = 8;

fn main() {
    println!("Solutions for 8x8 chessboard :");

    let mut tracker = BackTracker::new();

    let nbsolutions = nreines(DEFAULT_DIM, &mut tracker);

    println!("{} solutions !\n", nbsolutions);

    for n in 2..25 {
        tracker = BackTracker::new();

        let start = SystemTime::now();

        let found = solution_nreines(n, &mut tracker, false);

        let end = SystemTime::now();

        let duration = end.duration_since(start).unwrap();

        println!(
            "{:>2.0} : {:>9} in {:<8.5}ms",
            n,
            if found { "found" } else { "not found" },
            duration.as_secs() * 1000 + duration.subsec_millis() as u64,
        );
    }
}
